>From 9d54a3f9e4a963d3f33be61b9a7b40c124a0cc8f Mon Sep 17 00:00:00 2001
From: Erwan Tulou <brezhoneg1@yahoo.fr>
Date: Thu, 11 Jun 2009 00:09:44 +0200
Subject: [PATCH] make sure make_URI and decode_URI work for Windows platforms

---
 src/text/strings.c |   14 +++++++++++++-
 1 files changed, 13 insertions(+), 1 deletions(-)

diff --git a/src/text/strings.c b/src/text/strings.c
index c73dec6..b69facd 100644
--- a/src/text/strings.c
+++ b/src/text/strings.c
@@ -78,6 +78,14 @@ char *decode_URI( char *psz )
     if( psz == NULL )
         return NULL;
 
+#ifdef WIN32
+    if ( strlen (psz) > 2 &&
+        (psz[0] == '/') && isalpha (psz[1]) && (psz[2] == ':'))
+    {
+        in++;
+    }
+#endif
+
     while( ( c = *in++ ) != '\0' )
     {
         switch( c )
@@ -99,6 +107,10 @@ char *decode_URI( char *psz )
                 *out++ = ' ';
                 break;
 
+            case '/':
+                *out++ = DIR_SEP_CHAR;
+                break;
+
             default:
                 /* Inserting non-ASCII or non-printable characters is unsafe,
                  * and no sane browser will send these unencoded */
@@ -1094,7 +1106,7 @@ char *make_URI (const char *path)
 
         if (getcwd (cwd, sizeof (cwd)) == NULL) /* FIXME: UTF8? */
             return NULL;
-        if (asprintf (&buf, "%s/%s", cwd, path) == -1)
+        if (asprintf (&buf, "%s" DIR_SEP "%s", cwd, path) == -1)
             return NULL;
         char *ret = make_URI (buf);
         free (buf);
-- 
1.5.6.5

